<template>
  <div class="writer">
      <textarea
          class="writer__input"
          v-model="value"
          @keydown.tab.prevent="tabHandler"
          @keydown.enter.prevent="handleEnter"
      />
  </div>
</template>

<style lang="scss">
.writer {
  height: 100%;
  overflow: hidden;

  &__input {
    border: none;
    outline: none;
    box-shadow: none;
    resize: none;
    padding: 16px;
    height: 100%;
    width: 100%;
    overflow: auto;
    word-break: break-all;
    background: transparent;
    color: inherit;
  }
}
</style>

<script lang="ts">
import {defineComponent} from 'vue'

export default defineComponent({
  name: 'Writer',

  props: {
    modelValue: {
      type: String,
      default: ''
    }
  },

  computed: {
    value: {
      get () {
        return this.modelValue;
      },
      set(data: string) {
        this.$emit('update:modelValue', data);
      }
    }
  },

  emits: ['update:modelValue'],

  methods: {
    handleEnter(event: KeyboardEvent) {
      const text = this.modelValue;
      const target = (event.target as HTMLInputElement);
      const originalSelectionStart = target.selectionStart;

      if (!!originalSelectionStart) {
        const textStart = text.slice(0, originalSelectionStart);
        const textEnd = text.slice(originalSelectionStart);
        const line = textStart.slice(textStart.lastIndexOf("\n") + 1);

        let addition = "\n";
        let selectionPosition = originalSelectionStart + 1;

        if (['*', '-'].some(listChar => line.startsWith(listChar))) {
          addition = addition + textStart.charAt(textStart.lastIndexOf("\n") + 1) + ' ';
          selectionPosition = selectionPosition + addition.length -1
        }

        this.value = `${textStart}${addition}${textEnd}`;
        this.$nextTick(() => {
          target.selectionEnd = target.selectionStart = selectionPosition;
        });
      }
    },

    tabHandler(event: KeyboardEvent) {
      const text = this.modelValue;
      const target = (event.target as HTMLInputElement);
      const originalSelectionStart = target.selectionStart;

      if (!!originalSelectionStart) {
        const textStart = text.slice(0, originalSelectionStart);
        const textEnd = text.slice(originalSelectionStart);

        this.value = `${textStart}    ${textEnd}`;

        this.$nextTick(() => {
          target.selectionEnd = target.selectionStart = originalSelectionStart + 1;
        });
      }
    }
  }
});
</script>

